# Abstract

This tool allows editing a point cloud.

## Functions:

1. Moving and rotating the point cloud
2. Deleting points
3. Automatic orientation from cloud to a planar surface (e.g. the floor)
4. Saving the edited point cloud

Run

```rosrun pointcloud_editor pointcloud_editor_node /path/to/pointcloud.pcd [-nc]```

**-nc:** disables the automatic colorization of the points according to their height

# Functions

There are two groups of functions (modes). 
The first mode allows transformations of the cloud and the second deletion of points. 
You can see in the bottom left corner which mode is active. 
**The mode can be switched by pressing the m-key.**
**The following refers to the keys on the numpad.**

## Transformations:

**6 and 4:** moving the cloud along the x-axis

**9 and 3:** moving the cloud along the y-axis

**8 and 2:** moving the cloud along the z-axis

**shift + 6 and shift + 4:** rotation around the x-axis

**shift + 9 and shift + 3:** rotation around the y-axis

**shift + 8 and shift + 2:** rotation around the z-axis

**5 or shift + 5:** in- or decreasing the step size for translation or rotation

## Deleting:

In this mode you can see a cube that represents the volume that is going to be deleted.
This cube can be modified by the following keys. 
Furthermore it's possible to set an initial position by marking one point using shift + left mouse button.
If you mark additional points the cube is going to be spun around them.

**6 and 4:** enlarge the cube along the x-axis

**9 and 3:** enlarge the cube along the y-axis

**8 and 2:** enlarge the cube along the z-axis

**shift + 6 and shift + 4:** shrink the cube along the x-axis

**shift + 9 and shift + 3:** shrink the cube along the y-axis

**shift + 8 and shift + 2:** shrink the cube along the z-axis

**5 or shift + 5:** in- or decrease the step size for enlarging and shrinking

**b:** remove points outside of the cube

**B:** remove points inside of the cube

**Del:** delete the marked points

## General:

**h:** opens help in terminal (similar to this text)

**l:** show or hide legend

**m:** change mode

**Backspace:** "undo"

**Numpad Enter:** save point cloud in /directory/of/transformed_pointcloud.pcd

## Bonus:

**1. Orientate the cloud towards the floor:**
For this purpose you have to mark a point on the ground. 
Choose this point in such a way that it lies on a planar surface and has some distance (0.5m) to other objects on said ground. 
The first marked point is used. 
If you are not pleased with your choice you have to use the Del-key to reset it and choose again. 
After choosing a suitable point press the n-key to orientate the floor of the cloud in such a way that it lies in the x-y-plane and is lowered by 20cm.

**2. Im- and exporting transformations:**
If you want to apply the same transformation to different clouds this is possible by displaying the current in the terminal. 

**t:** display current transformation as matrix

**T:** display current transformation in one line 

If you want to apply a transformation you have to press the X key first. 
Now it's possible to type in the transformation in the terminal. 
Use the same format as it is displayed when pressing the T-key. 
Confirm the input by pressing Enter in the terminal, switch to the window with the pointcloud and apply the transformation by pressing the x-key. 

**X:** open input for a transformation in the terminal

**x:** apply transformation
